<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeriesComprasERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeriesComprasERP
 * @subpackage Arrays
 */
class ArrayOfSeriesComprasERP extends AbstractStructArrayBase
{
    /**
     * The SeriesComprasERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeriesComprasERP[]
     */
    public $SeriesComprasERP;
    /**
     * Constructor method for ArrayOfSeriesComprasERP
     * @uses ArrayOfSeriesComprasERP::setSeriesComprasERP()
     * @param \StructType\SeriesComprasERP[] $seriesComprasERP
     */
    public function __construct(array $seriesComprasERP = array())
    {
        $this
            ->setSeriesComprasERP($seriesComprasERP);
    }
    /**
     * Get SeriesComprasERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeriesComprasERP[]|null
     */
    public function getSeriesComprasERP()
    {
        return isset($this->SeriesComprasERP) ? $this->SeriesComprasERP : null;
    }
    /**
     * Set SeriesComprasERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeriesComprasERP[] $seriesComprasERP
     * @return \ArrayType\ArrayOfSeriesComprasERP
     */
    public function setSeriesComprasERP(array $seriesComprasERP = array())
    {
        foreach ($seriesComprasERP as $arrayOfSeriesComprasERPSeriesComprasERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeriesComprasERPSeriesComprasERPItem instanceof \StructType\SeriesComprasERP) {
                throw new \InvalidArgumentException(sprintf('The SeriesComprasERP property can only contain items of \StructType\SeriesComprasERP, "%s" given', is_object($arrayOfSeriesComprasERPSeriesComprasERPItem) ? get_class($arrayOfSeriesComprasERPSeriesComprasERPItem) : gettype($arrayOfSeriesComprasERPSeriesComprasERPItem)), __LINE__);
            }
        }
        if (is_null($seriesComprasERP) || (is_array($seriesComprasERP) && empty($seriesComprasERP))) {
            unset($this->SeriesComprasERP);
        } else {
            $this->SeriesComprasERP = $seriesComprasERP;
        }
        return $this;
    }
    /**
     * Add item to SeriesComprasERP value
     * @throws \InvalidArgumentException
     * @param \StructType\SeriesComprasERP $item
     * @return \ArrayType\ArrayOfSeriesComprasERP
     */
    public function addToSeriesComprasERP(\StructType\SeriesComprasERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeriesComprasERP) {
            throw new \InvalidArgumentException(sprintf('The SeriesComprasERP property can only contain items of \StructType\SeriesComprasERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SeriesComprasERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeriesComprasERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeriesComprasERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeriesComprasERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeriesComprasERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeriesComprasERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeriesComprasERP
     */
    public function getAttributeName()
    {
        return 'SeriesComprasERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSeriesComprasERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
